package entity;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

/**
 *
 * @author java@htl-leonding
 */
@Entity
@Table(name = "SW_ITEM")
@NamedQueries({
    @NamedQuery(name = "Item.findAll", query = "SELECT i FROM Item i"),
    @NamedQuery(name = "Item.findByItmId", query = "SELECT i FROM Item i WHERE i.id = :itmId"),
    @NamedQuery(name = "Item.findByItmUnitprice", query = "SELECT i FROM Item i WHERE i.unitPrice = :itmUnitprice"),
    @NamedQuery(name = "Item.findByItmQuantity", query = "SELECT i FROM Item i WHERE i.quantity = :itmQuantity"),
    @NamedQuery(name = "Item.findByItmDiscount", query = "SELECT i FROM Item i WHERE i.discount = :itmDiscount")})
public class Item implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "ITM_ID")
    private Long id;
    @Column(name = "ITM_UNITPRICE")
    private double unitPrice;
    @Column(name = "ITM_QUANTITY")
    private double quantity;
    @Column(name = "ITM_DISCOUNT")
    private double discount;
    @JoinColumn(name = "ITM_PROD_ID", referencedColumnName = "PROD_ID")
    @ManyToOne
    private Product product;
    @JoinColumn(name = "ITM_ORD_ID", referencedColumnName = "ORD_ID")
    @ManyToOne
    private Ordering ordering;

    public Item() {
    }

    public double getDiscount() {
        return discount;
    }

    public void setDiscount(double discount) {
        this.discount = discount;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public double getQuantity() {
        return quantity;
    }

    public void setQuantity(double quantity) {
        this.quantity = quantity;
    }

    public double getUnitPrice() {
        return unitPrice;
    }

    public void setUnitPrice(double unitprice) {
        this.unitPrice = unitprice;
    }

    public Product getProduct() {
        return product;
    }

    public void setProduct(Product product) {
        this.product = product;
    }

    public Ordering getOrdering() {
        return ordering;
    }

    public void setOrdering(Ordering ordering) {
        this.ordering = ordering;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Item)) {
            return false;
        }
        Item other = (Item) object;
        if ((this.id == null && other.getId() != null) || (this.id != null && !this.id.equals(other.getId()))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entity.Item[itmId=" + id + "]";
    }

}
