package entity;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author java@htl-leonding
 */
@Entity
@Table(name = "SW_ORDERING")
@NamedQueries({
    @NamedQuery(name = "Ordering.findAll", query = "SELECT o FROM Ordering o"),
    @NamedQuery(name = "Ordering.findById", query = "SELECT o FROM Ordering o WHERE o.id = :ordId"),
    @NamedQuery(name = "Ordering.findByOrderdate", query = "SELECT o FROM Ordering o WHERE o.orderdate = :ordOrderdate"),
    @NamedQuery(name = "Ordering.findByRequireddate", query = "SELECT o FROM Ordering o WHERE o.requireddate = :ordRequireddate"),
    @NamedQuery(name = "Ordering.findByShippeddate", query = "SELECT o FROM Ordering o WHERE o.shippeddate = :ordShippeddate"),
    @NamedQuery(name = "Ordering.findByFreight", query = "SELECT o FROM Ordering o WHERE o.freight = :ordFreight"),
    @NamedQuery(name = "Ordering.findByCustomer", query = "SELECT o FROM Ordering o WHERE o.customer.id = :ordCustomerId")
})
public class Ordering implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "ORD_ID")
    private Long id;
    @Column(name = "ORD_ORDERDATE")
    @Temporal(TemporalType.DATE)
    private Date orderdate;
    @Column(name = "ORD_REQUIREDDATE")
    @Temporal(TemporalType.DATE)
    private Date requireddate;
    @Column(name = "ORD_SHIPPEDDATE")
    @Temporal(TemporalType.DATE)
    private Date shippeddate;
    @Column(name = "ORD_FREIGHT")
    private double freight;
    @OneToMany(mappedBy = "ordering")
    private List<Item> itemList;
    @JoinColumn(name = "ORD_CUST_ID", referencedColumnName = "CUST_ID")
    @ManyToOne
    private Customer customer;

    public Ordering() {
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public double getFreight() {
        return freight;
    }

    public void setFreight(double freight) {
        this.freight = freight;
    }

    public Date getOrderdate() {
        return orderdate;
    }

    public void setOrderdate(Date orderdate) {
        this.orderdate = orderdate;
    }

    public Date getRequireddate() {
        return requireddate;
    }

    public void setRequireddate(Date requireddate) {
        this.requireddate = requireddate;
    }

    public Date getShippeddate() {
        return shippeddate;
    }

    public void setShippeddate(Date shippeddate) {
        this.shippeddate = shippeddate;
    }

    public List<Item> getItemList() {
        return itemList;
    }

    public void setItemList(List<Item> itemList) {
        this.itemList = itemList;
    }

    public Customer getCustomer() {
        return customer;
    }

    public void setCustomer(Customer customer) {
        this.customer = customer;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Ordering)) {
            return false;
        }
        Ordering other = (Ordering) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entity.Ordering[ordId=" + id + "]";
    }

}
