package entity;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 *
 * @author java@htl-leonding
 */
@Entity
@Table(name = "SW_PRODUCT")
@NamedQueries({
    @NamedQuery(name = "Product.findAll", query = "SELECT p FROM Product p"),
    @NamedQuery(name = "Product.findByid", query = "SELECT p FROM Product p WHERE p.id = :id"),
    @NamedQuery(name = "Product.findByProdName", query = "SELECT p FROM Product p WHERE p.name = :prodName"),
    @NamedQuery(name = "Product.findByProdUnitprice", query = "SELECT p FROM Product p WHERE p.unitPrice = :prodUnitprice"),
    @NamedQuery(name = "Product.findByProdUnitsinstock", query = "SELECT p FROM Product p WHERE p.unitsInStock = :prodUnitsinstock"),
    @NamedQuery(name = "Product.findByProdUnitsonorder", query = "SELECT p FROM Product p WHERE p.unitsOnOrder = :prodUnitsonorder"),
    @NamedQuery(name = "Product.findByProdReorderlevel", query = "SELECT p FROM Product p WHERE p.reorderLevel = :prodReorderlevel"),
    @NamedQuery(name = "Product.findByProdDiscontinued", query = "SELECT p FROM Product p WHERE p.discontinued = :prodDiscontinued")})
public class Product implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "PROD_ID")
    private Long id;
    @Column(name = "PROD_NAME")
    private String name;
    @Column(name = "PROD_UNITPRICE")
    private double unitPrice;
    @Column(name = "PROD_UNITSINSTOCK")
    private int unitsInStock;
    @Column(name = "PROD_UNITSONORDER")
    private int unitsOnOrder;
    @Column(name = "PROD_REORDERLEVEL")
    private int reorderLevel;
    @Column(name = "PROD_DISCONTINUED")
    private int discontinued;
    @OneToMany(mappedBy = "product")
    private List<Item> itemList;

    public Product() {
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public boolean isDiscontinued() {
        // nur bei Objekttyp als Attributtyp
        // if (discontinued == null) { return null };
        return discontinued == 1 ? Boolean.TRUE : Boolean.FALSE;
    }

    public void setDiscontinued(boolean discontinued) {
        // nur bei Objekttyp als Attributtyp
        //if (discontinued == null) {
        //    this.discontinued = null;
        //} else {
        this.discontinued = discontinued ? 1 : 0;
        //}
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }


    public int getReorderLevel() {
        return reorderLevel;
    }

    public void setReorderLevel(int reorderLevel) {
        this.reorderLevel = reorderLevel;
    }

    public double getUnitPrice() {
        return unitPrice;
    }

    public void setUnitPrice(double unitPrice) {
        this.unitPrice = unitPrice;
    }

    public int getUnitsInStock() {
        return unitsInStock;
    }

    public void setUnitsInStock(int unitsInStock) {
        this.unitsInStock = unitsInStock;
    }

    public int getUnitsOnOrder() {
        return unitsOnOrder;
    }

    public void setUnitsOnOrder(int unitsOnOrder) {
        this.unitsOnOrder = unitsOnOrder;
    }



    public List<Item> getItemList() {
        return itemList;
    }

    public void setItemList(List<Item> itemList) {
        this.itemList = itemList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Product)) {
            return false;
        }
        Product other = (Product) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.getId()))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entity.Product[id=" + id + "]";
    }
}
